<template>
  <div>
    <div>
      <add-card-item
        :image="'savoirs.svg'"
        :enable="true"
        @click.native="openModal({})"
      />
    </div>
    <div
      class="grid grid-cols-1 sm:grid-cols-2 md:grid-cols-3 xl:grid-cols-4 gap-8 py-5 w-full"
    >
      <div v-for="savoir in savoirs" :key="savoir.id">
        <div>
          <mat-comp-sav-card-item
            :matCompSav="savoir"
            :imageName="'savoirs.svg'"
            @onUpdateClick="openModal(savoir)"
          />
        </div>
      </div>
    </div>
    <modal-savoir
      :updatedSavoir="updatedSavoir"
      :forCompetence="competence"
      :value="modalOpen"
      v-if="modalOpen"
      @closeRequest="modalOpen = false"
    />
    <modal-no-bulletin-created :value="bulletinModalOpen" />
  </div>
</template>

<script>
import AddCardItem from "../AddCardItem.vue";
import MatCompSavCardItem from "../MatCompSavCardItem.vue";
import ModalSavoir from "../modals/ModalAddSavoir.vue";
import ModalNoBulletinCreated from "../modals/ModalNoBulletinCreated.vue";
export default {
  components: {
    MatCompSavCardItem,
    AddCardItem,
    ModalSavoir,
    ModalNoBulletinCreated,
  },
  created() {
    this.$emit("titleChanged", this.$attrs.title + this.competence.nom);
/*     this.$store.dispatch("bindSavoirs", this.classe);
    this.$store.dispatch("bindBulletins", this.classe); */
  },
  data() {
    return {
      modalOpen: false,
      bulletinModalOpen: false,
      updatedSavoir: Object,
    };
  },
  computed: {
    competence() {
      return this.$store.getters.getOneCompetence(
        this.$route.params.competenceid
      );
    },

    bulletins() {
      return this.$store.state.bulletins;
    },

    savoirs() {
      return this.$store.getters.getSavoirsByCompetence(this.competence);
    },

    classe() {
      return this.$store.getters.getOneClasse(this.$route.params.classeid);
    },
  },
  methods: {
    openModal(updatedSavoir) {
      if (this.bulletins.length === 0) this.bulletinModalOpen = true;
      else {
        this.updatedSavoir = updatedSavoir;
        this.modalOpen = true;
      }
    },
  },
};
</script>

<style>
</style>